#pragma once
#include "BaseDlgStyleOne.h"

const UINT WM_CI_HTTPDOWNLOAD_THREAD_FINISHED = WM_APP + 1;

#define FRAME_WIDTH				4

#define CI_COLOR_NORMAL_TEXT		(RGB(34, 34, 34))		// #222222
#define CI_COLOR_NORMAL_BK			(RGB(255, 255, 255))
#define CI_COLOR_STATIC_TEXT		(RGB(78, 157, 199))		// #4e9dc7
#define CI_COLOR_LIST_BORDER		(RGB(220,220,220))		// #dcdcdc
#define CI_COLOR_IMAGE_BORDER		(RGB(198, 198, 198))	// #c6c6c6

class CProfileDlgController;

class CCallerInfoDlg : public CBaseDlgStyleOne, 
    private IGTWASActorEvent ,
    private IGTMessengerActorEvent
{
public:
	CCallerInfoDlg(CString strID, CString strTelNo, CWnd* pParent);   // ǥ Դϴ.
	virtual ~CCallerInfoDlg();

	DECLARE_DYNAMIC(CCallerInfoDlg)

	void __ResourceLoad(BOOL bInit = FALSE);
	void SetReadOnly(BOOL bReadOnly);
	CString GetID()	{return m_strID;}

	enum { IDD = IDD_CALLER_INFO_DIALOG };

protected:
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedOk();
	afx_msg LRESULT OnThreadFinished(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);

private:
	static UINT _DownloadThread(LPVOID pParam);
	static void CALLBACK _OnStatusCallBack(HINTERNET hInternet, DWORD_PTR dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength);

	virtual bool OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);

	void DownloadThread();
	void InitControls();
	void DownloadPicture(CString strURL);
	void RequestInfo(void);
	void DrawProfileImage(CString &strImageFilePath);
	RectF GetFitSizeInRect(const SizeF &sizeMax, const SizeF &sizeOrg);
	void CloseAllInternetHandle();
	bool IsCloseMsg( MSG* pMsg );

	CStatic m_stPicture;			// 
	CStatic m_staticName;			// ̸
	CString m_strName;	
	CStatic m_staticPart;			// Ҽ
	CStatic m_staticPosition;		// å
	CStatic m_staticWorkTel;		// ȸȭ
	CStatic m_staticCellPhone;		// ޴
	CStatic m_staticExtention;		// ȣ
	CString       m_sServer; 
	CString       m_sObject; 
	CString       m_sFilename;
	INTERNET_PORT m_nPort;
	DWORD         m_dwServiceType;
	HINTERNET     m_hInternetSession;
	HINTERNET     m_hHttpConnection;
	HINTERNET     m_hHttpFile;
	BOOL          m_bAbort;
	BOOL          m_bSafeToClose;
	CFile         m_FileToWrite;
	CPen		  m_penBorder;
	CPen		  m_penImageBorder;

	CString m_strID;	//    ϴ ID
	CString m_strMyID;	//  ID (m_strID   , ٸ  )
	CString m_strTelNo;

	CButton		  m_btnOK;
	CWinThread*   m_pThread;
	IGTWASActor  *m_pWASActor;	  
	trid_t		  m_trid;

	NE_MEMBER_DATA m_userData;
	CNeMessengerDlg *m_pParentDlg;	// θâ ( θâ ˷־ deleteϱ )
protected:
	virtual void OnCancel();
};
